'''
KvCam- Simple Camera app built in Kivy and Python.
                 Copyright (C) 2024
                    Sameer Sharma

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see https://www.gnu.org/licenses/.
'''

import kivy
kivy.require("2.3.0")
from kivy.config import Config
Config.set('input', 'mouse', 'mouse,multitouch_on_demand')
Config.set('kivy', 'log_level', 'warning')
from platformdirs import *
from kivy.app import App
from kivy.uix.camera import Camera
from kivy.uix.screenmanager import ScreenManager, Screen
from kivy.core.window import Window
from kivy.properties import ObjectProperty
import time
import threading
import subprocess
import webbrowser
import os
import os.path

class MainScreen(Screen):
    pbutton= ObjectProperty(None)
    abutton= ObjectProperty(None)
    
    def capture(self):
        Camera.play = True
        pics= user_pictures_path()
        Camera.export_to_png("pics/pic.png")
        print("Captured")
        
    def pause(self):
        Camera.play= False
        
    def athread(self):
        threading.Thread(target=self.about).start()

    def about(self):
        webbrowser.open('https://gatimaan.codeberg.page')

    def pthread(self):
        threading.Thread(target=self.pics).start()

    def pics(self):
        pics= user_pictures_path()
        path= f"{pics}/Gatimaan"
        check= os.path.exists(path)
        if os.path.exists(path) and not os.path.isfile(path):
            confirm= not os.listdir(path)
        if check==True and confirm==False:
            cmd=f"xdg-open {path}"
            subprocess.call(cmd, shell=True)
        else:
            print()

class WindowManager(ScreenManager):
    pass

class kvcam(App):
    icon = 'packaging/kvcam.png'
    title = 'KvCam'
    def build(self):
        sm=ScreenManager()
        sm.add_widget(MainScreen(name='main'))
        return sm
    
if __name__=='__main__':
    kvcam().run()
    Window.close()
